<template>
  <div v-if="editMode">
    <!-- <div contenteditable="true" @input="update">{{ textfieldEditedData }}</div> -->
    <ckeditor type="inline" v-model="fieldData"></ckeditor>
  </div>
  <div v-else-if="textfieldData">
    {{ textfieldData }}
  </div>
  <div v-else>
    <slot></slot>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

export default {
  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      editMode: 'Y3TI/editMode'
    }),

    textfieldData () {
      return _.get(this.node, this.path)
    },

    textfieldEditedData () {
      return this.getEditedField({ node: this.node, path: this.path })
    },

    fieldData: {
      get () {
        // return _.get(this.$store.state.app.edited, this.editablePath)
        return this.getEditedField({ node: this.node, path: this.path })
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: value } })
      }
    }
  },

  methods: {
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    }),

    update (e) {
      this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: e.target.innerHTML } })
    }
  }
}
</script>

<style lang="scss" scoped>
</style>
